var OnChangeLanguage_vmd = null;
var pageTranslators_vmd = [];
var vmUrl = '/apps/vmdashboard/includes/index.php';
var vmdetailinfo = {};
var vmuuid = '';
var backhtml = '/apps/vmdashboard/pc/vm/vm.html';
var uploadFilerrcode = {
  '9999': 'File upload failed',
  '9984': 'Not logged in',
  '9996': 'Chunk verification failed',
  '9930': 'Forbid to write into system disk',
  '9993': 'File exists',
  '9916': 'Write failed',
  '9897': 'Open file failed',
}

OnChangeLanguage_vmd = function(e) {
  for (var i = 0; i < pageTranslators_vmd.length; i++) {
    var node = pageTranslators_vmd[i].node;
    var p = pageTranslators_vmd[i].translateProperty;
    node[p] = window.top.UNAS._(pageTranslators_vmd[i].originalText);
  }

  if (e) {

  }

  function vmdTranslator(id) {
    let rt_c = document.getElementById(id);
    if (!rt_c) {
      return;
    }
    var tmp_pageTranslators = window.top.UNAS.CreateNodesTranslators(rt_c);
    pageTranslators_vmd = pageTranslators_vmd.concat(tmp_pageTranslators);
    OnChangeLanguage_vmd();
  }
  window.vmdTranslator = vmdTranslator;
};
OnChangeLanguage_vmd();
window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_vmd);
window.addEventListener("unload", function(e) {
  window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_vmd);
}, false);

function updatevmpage(url, fn) {
  jQuery('#jv-vmd-main').css('opacity', '0');
  jQuery.ajaxSetup({
    cache: false
  });

  jQuery('#jv-vmd-main').load(url + '?=v=6.1.34', function(res) {
    setTimeout(function() {
      jQuery('#jv-vmd-main').animate({
        opacity: '1'
      }, 100);
      vmdTranslator('jv-vmd-network-page');
    }, 200)
    if (fn && typeof fn === "function") {
      fn();
    }
  })
}

function vm_confirmalertWindowFn(data, fn) {
  var url = '/apps/vmdashboard/pc/public/confirmAlert.html?=v=6.1.34&'
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tip'),
    modal: true,
    modalOverlayClose: false,
    width: 350,
    height: 160,
    data: data,
    contentURL: url
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function timeToTimestamp_vm(time) {
  var [hours, minutes] = time.split(':').map(Number);
  var date = new Date();
  date.setHours(hours, minutes, 0, 0);
  return date.getTime();
}

function vm_alertWindowFn(data, fn) {
  var url = '/apps/vmdashboard/pc/public/alert.html?=v=6.1.34&'
  if (data.isck) {
    url = '/apps/vmdashboard/pc/public/alert_ck.html?=v=6.1.34&'
  }
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tip'),
    modal: true,
    modalOverlayClose: false,
    width: 550,
    height: 260,
    data: data,
    contentURL: url
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function vm_errorWindowFn(data) {

  var errorWindow = new MUI.Modal({
    id: 'jv-errorWindow',
    title: UNAS._('Tip'),
    modal: true,
    modalOverlayClose: false,
    width: 450,
    height: 260,
    data: data,
    contentURL: '/apps/vmdashboard/pc/public/error.html?=v=6.1.34&'
  });
  errorWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function vm_succeedWindowFn(data) {

  var succeedWindow = new MUI.Modal({
    id: 'jv-succeedWindow',
    title: UNAS._('Tip'),
    modal: true,
    modalOverlayClose: false,
    width: 450,
    height: 260,
    data: data,
    contentURL: '/apps/vmdashboard/pc/public/succeed.html?=v=6.1.34&'
  });
  succeedWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function selectfiletree(type, t) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var selectfileWindow = new MUI.Modal({
    id: 'jv-selectfileWindow',
    title: UNAS._("Select Directory"),
    contentURL: '/apps/vmdashboard/pc/public/selectfile.html',
    modal: true,
    modalOverlayClose: false,
    data: {
      filetype: type,
      target: target
    },
    width: 650,
    height: 380
  });
}
// -------------------------------------------
function loadTree_vmd(d, type, t) {
  jQuery(d).parent().addClass('wait');
  jQuery.ajax({
    url: vmUrl,
    type: "POST",
    contentType: 'application/json',
    timeout: 30000,
    dataType: "json",
    data: JSON.stringify({
      cmd: "vm_list_dir",
      token: UToken,
      params: {
        dir: jQuery(d).attr('rel'),
        ext: type
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      var data = res.results || [];
      jQuery(d).parent().removeClass('wait');
      var subTree = '<ul class="isoJqueryFileTree collapsed" style="">';
      if (data.length === 0) {
        subTree += '<li><i>' + UNAS._('##$@zfs@$##Empty directory...##$@zfs@$##') + '</i></li>';
      } else {
        var filetype = ['file', 'raw', 'qcow2', 'img', 'vmdk', 'vhdx', 'vdi', 'ova', 'iso', 'disk'];
        data.forEach(function(v) {
          if (v.type == 'dir') {
            subTree += '<li class="directory collapsed">';
            subTree += '<a href="#" rel="' + v.path + '">' + v.name + '</a>';
            subTree += '</li>';
          } else if (filetype.indexOf(v.type) > -1) {
            subTree += '<li class="file ext_iso">';
            subTree += '<a href="#" rel="' + v.path + '">' + v.name + '</a>';
            subTree += '</li>';
          }
        });
      }
      subTree += '</ul>';
      jQuery(d).parent().append(subTree);
      jQuery(d).parent().find('ul').slideDown('fast', function() {
        jQuery(d).parent().removeClass('collapsed').addClass('expanded');
      });
      bindTree_vmd(jQuery(d).parent().find('ul'), type, t);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      jQuery(d).parent().removeClass('wait');
      alert(textStatus);
    }
  });
}


function bindTree_vmd(d, type, t) {
  var target = t;
  jQuery(d).find('li a').bind('click', function() {
    if (jQuery(this).parent().hasClass('directory')) {
      if (jQuery(this).parent().hasClass('collapsed')) { // Expand
        loadTree_vmd(jQuery(this), type, target);
      } else {
        jQuery(this).parent().find('ul').slideUp('fast', function() {
          jQuery(this).parent().removeClass('expanded').addClass('collapsed');
          jQuery(this).parent().find('ul').remove();
        });
      }
      if (type == 'dir') {
        jQuery(target).val(jQuery(this).attr('rel'));
        UNAS.Event.fireEvent('dirChange');
      }


    } else {
      jQuery(target).val(jQuery(this).attr('rel'));
      UNAS.Event.fireEvent('sourceChange');
      jQuery(target).siblings('.collapse').hide().children().html('');
    }

    if (jQuery(target).val()) {
      jQuery(target).attr('class', 'unas_input');
    }
    return false;
  });
}


function toggleFiletree_vmd(type) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  event.stopPropagation()
  jQuery(target).parents('.vm-item').siblings().find('.collapse').hide();
  if (jQuery(target).siblings('.collapse').css('display') === 'none') {
    initTreeData_vmd(target, type);
  } else {
    jQuery(target).siblings('.collapse').hide().children().html('');
  }

  jQuery(document).on('click', function(e) {
    e.stopPropagation();
    jQuery(target).siblings('.collapse').hide().children().html('');
  })

}

function initTreeData_vmd(t, type) {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: "json",
      cache: false,
      timeout: 30000,
      data: JSON.stringify({
        cmd: "vm_sharefolder",
        token: UToken
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(data) {

        var arrays = data.results || [];
        var mnt = '<ul class="isoJqueryFileTree" style="">';
        for (var i = 0; i < arrays.length; i++) {

          mnt += '<li class="directory collapsed">' +
            '<a href="#" rel="' + arrays[i] + '">' + arrays[i] + '</a>' +
            '</li>'

        }
        mnt += '</ul>';

        jQuery(t).siblings('.collapse').show().children().html(mnt);

        bindTree_vmd(jQuery(t).siblings('.collapse').children(), type, t);
        resolve(mnt)
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {

      }

    });
  })

}

function showpage(t, time = 200) {
  setTimeout(function() {
    jQuery(t).animate({
      opacity: '1'
    }, 200);
  }, time)
}
// ----------------------------------
function vmdTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

function generateRandomMacAddress() {
  let macAddress = "00";
  for (let i = 0; i < 5; i++) {
    macAddress += ":" + Math.floor(Math.random() * 256).toString(16).padStart(2, "0");
  }
  return macAddress.toLowerCase();
}

function addTimeZero_vm(num) {
  return num >= 10 ? num : '0' + num;
}

function formatDate_vm(d) {
  if (!d) {
    return '--';
  }
  var date = new Date(d * 1000);
  var YY = date.getFullYear() + '/';
  var MM = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '/';
  var DD = (date.getDate() < 10 ? '0' + (date.getDate()) : date.getDate());
  var hh = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
  var mm = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
  var ss = (date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds());
  return YY + MM + DD + " " + hh + mm;
};

(function() {
  jQuery('#jv-vmd-nav .nav-item').each(function(i, e) {
    e.onclick = function() {
      var link = jQuery(this).attr('link');
      if (jQuery(this).hasClass('current-nav-item')) {
        return;
      }
      jQuery(this).addClass('current-nav-item').siblings().removeClass('current-nav-item');
      updatevmpage('/apps/vmdashboard/pc/' + link + '/' + link + '.html');
    }
  })
})();
