function addvmdetsnpTime(h, m, w_i, days, t, i) {

  var i = i || new Date().getTime();
  var h = h || jQuery('#vmdetsnp_hours').val();
  var m = m || jQuery('#vmdetsnp_minutes').val();
  var w_i = w_i || jQuery('#vmdetsnp_weeks').val();
  var days = days || jQuery('#vmdetsnp_days').val();
  var timetype = t || jQuery('input[name=schedule_type]:checked').val();

  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];

  var timetext = '';
  switch (timetype) {
    case 'Daily':
      timetext = UNAS._('Daily') + ' ' + addTimeZero_vm(h) + ':' + addTimeZero_vm(m);
      break;
    case 'Weekly':
      timetext = UNAS._(week) + ' ' + addTimeZero_vm(h) + ':' + addTimeZero_vm(m);
      break;
    case 'Monthly':
      timetext = UNAS._('Monthly') + ' ' + days + UNAS._('st') + ' ' + addTimeZero_vm(h) + ':' + addTimeZero_vm(m);
      break;
    default:
  }

  var f = 0;
  jQuery('#jv-vmdetsnptimehost tr').each(function(i, e) {
    var content = jQuery(e).find('.timetx').attr('time');
    if (content == timetext) {
      f = 1;
      return;
    }
  })
  if (f) {
    return;
  }

  var tiemdom = vmdTemplateAppend('#jv-vmdetsnptimehost', 'jvt-vmdetsnptimeitem', 'jvt-vmdetsnptimeitem-' + i);

  tiemdom.find('.timetx').text(timetext).attr('time', timetext);
  tiemdom.find('.timetx').text(timetext).attr('val', timeToTimestamp_vm(h + ':' + m));
  switch (timetype) {
    case 'Daily':
      tiemdom.attr('h', h).attr('m', m).attr('week', '').attr('days', '');
      break;
    case 'Weekly':
      var w = (w_i == '0' ? 7 : w_i);
      tiemdom.attr('h', h).attr('m', m).attr('week', w).attr('days', '');
      break;
    case 'Monthly':
      tiemdom.attr('h', h).attr('m', m).attr('week', '').attr('days', days);
      break;
    default:
  }

  var asday = jQuery('#jv-asd-day-vmdetsnp').val();
  var total = jQuery('#jv-asd-total-vmdetsnp').val();

  jQuery('#jv-vmdetsnptimehost tr').sort(function(a, b) {
    var contentA = jQuery(a).find('.timetx').attr('val');
    var contentB = jQuery(b).find('.timetx').attr('val');
    return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
  }).appendTo('#jv-vmdetsnptimehost');

  tiemdom.find('.delete-icon').on('click', function() {
    jQuery(this).parents('tr').remove();

    // if (!jQuery('#jv-vmdetsnptimehost tr').children().length) {
    //   jQuery('#jv-vmdet-btn').attr('class', 'unas_button_sub_disabled');
    // }
  })

  // if (jQuery('#jv-vmdetsnptimehost tr').children().length && asday && total) {
  //   jQuery('#jv-vmdet-btn').attr('class', 'unas_button_sub');
  // }
}

function vmdet_snapshot_auto() {
  var domain = [vmdetailinfo.uuid],
    task = [];

  jQuery('#jv-vmdetsnptimehost tr').each(function(i, e) {
    var h = jQuery(e).attr('h') || '*';
    var m = jQuery(e).attr('m') || '*';
    var w = jQuery(e).attr('week') || '*';
    var d = jQuery(e).attr('days') || '*';
    task.push({
      cron: [m, h, d, '*', w]
    })
  })
  var params = {
    domain: domain,
    autosnap: {
      task: task,
      archive: {
        on: jQuery('#jv-isenablearchive-vmdetsnp').prop('checked'),
        day: +jQuery('#jv-asd-day-vmdetsnp').val(),
        total: +jQuery('#jv-asd-total-vmdetsnp').val()
      }
    }
  };

  jQuery.ajax({
    url: vmUrl,
    data: JSON.encode({
      cmd: "vm_snapshot_auto",
      token: UToken,
      params: params
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {},
    complete: function(xml) {
      MUI.closeWindow($('jv-autosnapshotWindow'));
      getvmdetail();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}


(function() {

  jQuery('#vmdetsnp_daily').click(function() {
    jQuery('#vmdetsnp_weeks_cont').attr('style', "display:none");
    jQuery('#vmdetsnp_days_cont').attr('style', "display:none");
    jQuery('#vmdetsnp_days_cont').prop('disabled', false);
  })
  jQuery('#vmdetsnp_weekly').click(function() {
    jQuery('#vmdetsnp_weeks_cont').attr('style', "display:block;");
    jQuery('#vmdetsnp_days_cont').attr('style', "display:none");
    jQuery('#vmdetsnp_weeks').prop('disabled', false);
  })
  jQuery('#vmdetsnp_monthly').click(function() {
    jQuery('#vmdetsnp_weeks_cont').attr('style', "display:none");
    jQuery('#vmdetsnp_days_cont').attr('style', "display:block;");
    jQuery('#vmdetsnp_days').prop('disabled', false);
  })

  jQuery("#jv-vmtimehostcontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  var sel_hour = jQuery('#vmdetsnp_hours');
  var sel_minutes = jQuery('#vmdetsnp_minutes');
  var sel_weeks = jQuery('#vmdetsnp_weeks');
  var sel_days = jQuery('#vmdetsnp_days');
  var weekArray = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
  for (var i = 0; i < 24; i++) {
    sel_hour.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 0; i < 60; i++) {
    sel_minutes.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 1; i < 7; i++) {
    sel_weeks.append('<option value="' + i + '">' + UNAS._(weekArray[i]) + '</option>');
  }
  sel_weeks.append('<option value="0">' + UNAS._(weekArray[0]) + '</option>');
  for (var i = 1; i <= 31; i++) {
    sel_days.append('<option value="' + i + '">' + i + '</option>');
  }


  jQuery('#jv-asd-day-vmdetsnp, #jv-asd-total-vmdetsnp').bind('input propertychange', function(e) {
    var day = jQuery('#jv-asd-day-vmdetsnp').val();
    var total = jQuery('#jv-asd-total-vmdetsnp').val();
    // var len = jQuery('#jv-vmdetsnptimehost tr').length;
    if (day && total) {
      jQuery('#jv-vmdet-btn').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-vmdet-btn').attr('class', 'unas_button_sub_disabled');
    }
  });
  var cron = vmdetailinfo.cronsnap;
  var tasks = cron.task || [];

  jQuery('#jv-isenablearchive-vmdetsnp').prop('checked', cron.archive.on);
  jQuery('#jv-asd-day-vmdetsnp').val(cron.archive.day);
  jQuery('#jv-asd-total-vmdetsnp').val(cron.archive.total);

  for (var i = 0; i < tasks.length; i++) {
    var t_ = tasks[i].cron; //分 时 日 月 周
    var h = t_[1] == '*' ? '0' : t_[1];
    var m = t_[0] == '*' ? '0' : t_[0];
    var w_i = t_[4] == '*' ? '' : t_[4];
    var days = t_[2] == '*' ? '' : t_[2];

    var t = 'Daily';
    if (w_i) {
      t = 'Weekly';
    } else if (days) {
      t = 'Monthly';
    } else {
      t = 'Daily';
    }
    addvmdetsnpTime(h, m, w_i, days, t, i);
  }
})()
