var cmds = {
  reboot: 'vm_power_reboot',
  reset: 'vm_power_reset',
  poweron: 'vm_power_on',
  resume: 'vm_power_resume',
  shutdown: 'vm_power_off',
  destroy: 'vm_power_destroy',
  delete: 'vm_domain_undefine',
  pause: 'vm_suspend',
  force: 'vm_suspend_rm'
}
var vmdetailinfo = {};
var sw = 0;
// 后台任务检查
function vm_dettail_tasks() {
  jQuery('#jv-vmvmdetail-loading').show();
  clearTimeout(window.taskstimerdettail);
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "vm_bg_tasks",
      token: UToken
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};

        var is_task = 0;
        for (var v in info) {
          if (info.hasOwnProperty(v)) {
            if (info[v].length) {
              is_task = 1;
            }
          }
        }

        if (info.managedsave.length) {
          if (jQuery('#jv-vmdetail-page').length) {
            window.taskstimerdettail = setTimeout(function() {
              vm_dettail_tasks();
              clearTimeout(window.taskstimerdettail);
            }, 3000);
          } else {
            clearTimeout(window.taskstimerdettail);
          }
        } else {
          jQuery('#jv-vmvmdetail-loading').hide();
          sw && getvmdetail();
        }
        sw = 1;
      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

// 后台任务检查
function vm_dettail_tasks_snapshot() {

  clearTimeout(window.taskstimerdettailsnapshot);
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.stringify({
      cmd: "vm_bg_tasks",
      token: UToken
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        jQuery('#jv-snapshotsing-host').empty();
        if (info.snapshot.length) {
          if (jQuery('#jv-vmdetail-page').length) {
            for (var i = 0; i < info.snapshot.length; i++) {
              var shdom = vmdTemplateAppend('#jv-snapshotsing-host', 'jvt-snapshotsing-item', 'jvt-snapshotsing-item-' + i);
              shdom.attr('style', 'none');
              shdom.find('.jvc-snapshotsnmae').html(info.snapshot[i].NAME);
            }

            window.taskstimerdettailsnapshot = setTimeout(function() {
              vm_dettail_tasks_snapshot();
              clearTimeout(window.taskstimerdettailsnapshot);
            }, 3000);
          } else {
            clearTimeout(window.taskstimerdettailsnapshot);
          }
        } else {
          clearTimeout(window.taskstimerdettailsnapshot);
          getvmdetail();
        }

      }
    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

// power
function vm_power_control_detail(cmd, domains, type) {
  jQuery('#jv-vmvmdetail-loading').show();
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: cmd,
      token: UToken,
      params: {
        domains: domains
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      if (res.err == 0) {
        if (type == 'delete') {
          updatevmpage(backhtml);
        } else if (type == 'shutdown') {
          setTimeout(function() {
            getvmdetail();
          }, 2000)
        } else {
          getvmdetail();
        }

        if (type == 'pause') {
          UNAS.Event.addEvent('pause', function() {
            vm_domain_list();
          });
        }
      } else {
        vm_errorWindowFn({
          tips: UNAS._(res.errmsg)
        })
      }
    },
    complete: function(XMLHttpRequest, textStatus) {
      jQuery('#jv-vmvmdetail-loading').hide();
      vm_log();
      if (type == 'pause') {
        vm_dettail_tasks();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function getvmdetail() {
  clearTimeout(window.vmdetailcuptimer);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: 'vm_domain_list',
        token: UToken
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        var info = res.results || {};
        for (var i = 0; i < info.vm.length; i++) {
          if (info.vm[i].uuid == vmuuid) {
            vmdetailinfo = info.vm[i];
            break;
          }
        }

        vmdetailinfo.state = vmdetailinfo.state || {};
        var state = vmdetailinfo.state.state;
        var reason = vmdetailinfo.state.reason;

        getvmddetailstate(state, reason);

        jQuery('#jv-vmname').html(vmdetailinfo.name);

        if (vmdetailinfo.tpm) {
          jQuery('#jv-tpm').text('Open');
        } else {
          jQuery('#jv-tpm').text('Close');
        }
        jQuery('#jv-vmtype').text(vmdetailinfo.xml.attributes.type);
        jQuery('#jv-vmid').text(vmdetailinfo.xml.attributes.id);
        jQuery('#jv-vmemulator').text(vmdetailinfo.xml.devices.emulator).attr('title', vmdetailinfo.xml.devices.emulator);
        jQuery('#jv-vmbios').text(vmdetailinfo.bios);
        jQuery('#jv-vmcpumodel').text(vmdetailinfo.xml.cpu.attributes.mode);
        jQuery('#jv-vmarchitecture').text(info.cpu.model);
        jQuery('#jv-vmcpus').text(vmdetailinfo.xml.vcpu);
        var memory = UNAS.getReadableSizeString(vmdetailinfo.xml.memory * 1024);
        jQuery('#jv-vmmemory').text(memory);
        var port = vmdetailinfo.xml.devices.graphics.attributes.port;
        port = port == -1 ? '--' : port;
        jQuery('#jv-vmport').text(port);
        var address = vmdetailinfo.xml.devices.graphics.listen.attributes.address;
        address = address == '0.0.0.0' || address == '::' ? '##$@vmdashboard@$##Active##$@vmdashboard@$##' : '##$@vmdashboard@$##Disabled##$@vmdashboard@$##';
        jQuery('#jv-vmaddress').text(address);

        if (vmdetailinfo.auto_start) {
          jQuery('#jv-autostart-y').show();
          jQuery('#jv-autostart-n').hide();
          jQuery('#jv-startdelay').text(vmdetailinfo.auto_start_delay);
        } else {
          jQuery('#jv-autostart-y').hide();
          jQuery('#jv-autostart-n').show();
        }

        var vmdstate = 'Running';

        if (state == 1 || state == 7) {
          vmdstate = state == 1 ? 'Running' : 'Pmsuspend';
          jQuery('.jvc-resortdisks').hide();
          jQuery('#jv-addpcibtn').hide();
          jQuery('#jv-editvm').hide();
          jQuery('#jv-vmstate').css('color', '#1EB300');
          jQuery('#jv-vncport').attr('class', 'vncporttarget');
          jQuery('#jv-vncport').attr('href', '/apps/vmdashboard/noVNC/index.php?uuid=' + vmdetailinfo.uuid);
          jQuery('#jv-vnc').attr('src', '/apps/vmdashboard/noVNC/index.php?uuid=' + vmdetailinfo.uuid + '&embed=true');
          vm_domain_stat_detail([vmdetailinfo.uuid]);
        } else if (state == 3) {
          jQuery('#jv-vmstate').css('color', '#222');
          vmdstate = 'Paused';
          jQuery('#jv-vncport').addClass('vm-paused');
          jQuery('.jvc-resortdisks').hide();
          jQuery('#jv-addpcibtn').hide();
          jQuery('#jv-editvm').hide();

        } else if (state == 5) {
          jQuery('#jv-vmstate').css('color', '#222');
          if (reason == 5) {
            vmdstate = 'Paused';
            jQuery('#jv-vncport').addClass('vm-paused');
            jQuery('.jvc-resortdisks').hide();
            jQuery('#jv-addpcibtn').hide();
            jQuery('#jv-editvm').hide();
          } else {
            vmdstate = 'Shutoff';
            jQuery('#jv-editvm').show();
            jQuery('#jv-vncport').addClass('vm-shutdown');
            jQuery('.jvc-resortdisks').show();
            jQuery('#jv-addpcibtn').show();
          }
        }

        jQuery('#jv-vmstate').text('(' + '##$@vmdashboard@$##' + vmdstate + '##$@vmdashboard@$##' + ')');

        get_storagevolumes_list(vmdetailinfo);
        get_passthrough_list(vmdetailinfo);
        get_opticalstorage_list(vmdetailinfo);
        get_net_list(vmdetailinfo);
        get_pci_list(vmdetailinfo);
        get_usb_list(vmdetailinfo);
        get_snapshots_list(vmdetailinfo);

        vmdTranslator('jv-vmaddress');
        vmdTranslator('jv-vmstate');
        vmdTranslator('jv-tpm');
        vmdTranslator('jv-snapshotshost');

      },
      complete: function(XMLHttpRequest, textStatus) {
        vm_log();
        resolve(XMLHttpRequest);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        reject(XMLHttpRequest);
      }
    });
  })
}


function getvmddetailstate(state, reason) {
  jQuery('#jv-opbtnvm').css('opacity', 1);
  switch (state) {
    case 0:
      break;
    case 7:
    case 1:
      jQuery('.b_console').show();
      jQuery('.b_shutdown').show();
      jQuery('.b_reboot').show();
      jQuery('.b_pause').show();
      jQuery('.b_reset').show();
      jQuery('.b_poweroff').show();
      jQuery('.b_poweron').hide();
      jQuery('.b_delete').hide();
      jQuery('.b_resume').hide();
      jQuery('.b_forced').hide();
      jQuery('.b_resume_3').hide();
      break;
    case 2:
      break;
    case 3:
      jQuery('.b_console').hide();
      jQuery('.b_shutdown').hide();
      jQuery('.b_reboot').hide();
      jQuery('.b_pause').hide();
      jQuery('.b_reset').hide();
      jQuery('.b_poweroff').hide();
      jQuery('.b_poweron').show();
      jQuery('.b_delete').hide();
      jQuery('.b_resume').hide();
      jQuery('.b_resume_3').show();
      jQuery('.b_forced').hide();
      break;
    case 4:
      break;
    case 5:
      jQuery('.b_console').hide();
      jQuery('.b_shutdown').hide();
      jQuery('.b_reboot').hide();
      jQuery('.b_pause').hide();
      jQuery('.b_reset').hide();
      jQuery('.b_poweroff').hide();
      jQuery('.b_poweron').show();
      jQuery('.b_delete').show();
      jQuery('.b_resume').hide();
      jQuery('.b_forced').hide();
      jQuery('.b_resume_3').hide();
      if (reason == 5) {
        jQuery('.b_poweroff').hide();
        jQuery('.b_delete').hide();
        jQuery('.b_poweron').hide();
        jQuery('.b_resume').show();
        jQuery('.b_forced').show();
        jQuery('.b_reset').show();
      }
      break;
    case 6:
      break;
    default:
      jQuery('#jv-opbtnvm').css('opacity', 0);
  }
}

function vmdControlOp(t) {
  var uuids = [vmdetailinfo.uuid];
  var type = jQuery(t).attr('type');
  var ts = {
    shutdown: 'Shutdown',
    reboot: 'Reboot',
    pause: 'Pause(Save on Disk)',
    reset: 'Reset',
    destroy: 'Power off',
    forced: 'Power off'
  }

  if (type == 'delete') {
    var lan = UNAS._('##$@vmdashboard@$##Virtual Machines##$@vmdashboard@$##');
    var ts_d = UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##');
    var vmname = jQuery('#jv-vmname').text();
    vm_alertWindowFn({
      tips: ts_d + lan + ' ' + vmname + '?'
    }, function() {
      vm_power_control_detail(cmds[type], uuids, type);
    });
  } else {

    if (ts[type]) {
      var opt = UNAS._('##$@vmdashboard@$##' + ts[type] + '##$@vmdashboard@$##');
      vm_confirmalertWindowFn({
        tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to ##$@vmdashboard@$##') + opt + '?'
      }, function() {
        vm_power_control_detail(cmds[type], uuids, type);
      });
    } else {
      vm_power_control_detail(cmds[type], uuids, type);
    }
  }

}

function vmconsole() {
  window.open(jQuery('#jv-vncport').attr('href'), '_blank')
}
// 存储卷列表
function get_storagevolumes_list(vm) {
  var disk = vm.block || [];
  jQuery('#jv-storagevolumes-host').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    if (diskinfo.type == 'disk') {
      var svdom = vmdTemplateAppend('#jv-storagevolumes-host', 'jvt-sv-item', 'jvt-sv-item-' + i);
      svdom.attr('style', 'none').data('diskinfo', diskinfo);
      svdom.find('.jvc-volumename').text(diskinfo.path);
      svdom.find('.jvc-driver').text(diskinfo.xml.driver.attributes.type);
      svdom.find('.jvc-device').text(diskinfo.name);
      var capacity = diskinfo.capacity || 0;
      var allocation = diskinfo.allocation || 0;
      var physical = diskinfo.physical || 0;
      capacity && svdom.find('.jvc-capacity').text(UNAS.getReadableSizeString(capacity));
      allocation && svdom.find('.jvc-allocation').text(UNAS.getReadableSizeString(allocation));
      physical && svdom.find('.jvc-physical').text(UNAS.getReadableSizeString(physical));

      if (state == 1) {
        svdom.find('.edit-icon').hide();
      } else {
        svdom.find('.edit-icon').show();
      }
    }
  }

  vmdTranslator('jv-storagevolumes-host');
}

//系统镜像列表
function get_opticalstorage_list(vm) {
  var disk = vm.block || [];
  jQuery('#jv-opticalstorage-host').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    if (diskinfo.type == "cdrom") {
      var svdom = vmdTemplateAppend('#jv-opticalstorage-host', 'jvt-opticalstorage-item', 'jvt-opticalstorage-item-' + i);
      svdom.attr('style', 'none').data('diskinfo', diskinfo);
      svdom.find('.jvc-path').text(diskinfo.path);
      svdom.find('.jvc-driver').text(diskinfo.xml.driver.attributes.type);
      svdom.find('.jvc-device').text(diskinfo.name);
      svdom.find('.jvc-bus').text(diskinfo.xml.target.attributes.bus);
      if (state == 1) {
        svdom.find('.delete-icon').hide();
      } else {
        svdom.find('.delete-icon').show();
      }
    }
  }
  vmdTranslator('jv-opticalstorage-host');
}

//网络列表
function get_net_list(vm) {
  var disk = vm.xml.devices.interface || [];
  jQuery('#jv-networkhost').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    var netdom = vmdTemplateAppend('#jv-networkhost', 'jvt-network-item', 'jvt-network-item-' + i);
    netdom.attr('style', 'none').data('diskinfo', diskinfo);
    netdom.find('.jvc-netmodel').text(diskinfo.model.attributes.type);
    netdom.find('.jvc-macaddress').text(diskinfo.mac.attributes.address);
    netdom.find('.jvc-network').text(diskinfo.source.attributes.network);
    diskinfo.net && netdom.find('.jvc-type').text(diskinfo.net.type);
    diskinfo.net && netdom.find('.jvc-targetnet').text(diskinfo.net.bridge.attributes.name);
    if (state == 1) {
      netdom.find('.edit-icon').hide();
    } else {
      netdom.find('.edit-icon').show();
    }
    netdom.find('.edit-icon').on('click', function() {
      var editinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      addNetworkAdapterWindowFun({
        mac: editinfo.mac.attributes.address,
        model: editinfo.model.attributes.type,
        type: editinfo.source.attributes.network
      })
    })

    netdom.find('.delete-icon').on('click', function() {
      var editinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      var params = {
        domain: vmdetailinfo.uuid,
        mac: editinfo.mac.attributes.address
      }

      vm_alertWindowFn({
        tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
      }, function() {
        jQuery.ajax({
          type: "POST",
          url: vmUrl,
          dataType: 'json',
          data: JSON.encode({
            cmd: 'vm_domain_if_detach',
            token: UToken,
            params: params
          }),
          contentType: 'application/json;charset=utf-8',
          success: function(res) {
            if (res.err == 0) {
              getvmdetail();
            } else {
              vm_errorWindowFn({
                tips: UNAS._('Operation failed, please check the log')
              })
            }
          },
          complete: function(XMLHttpRequest, textStatus) {
            vm_log();
          },
          error: function(XMLHttpRequest, textStatus, errorThrown) {}
        });
      });
    })

  }
  vmdTranslator('jv-networkhost');
}

//直通磁盘列表
function get_passthrough_list(vm) {
  var disk = vm.block || [];
  jQuery('#jv-passthrough-host').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < disk.length; i++) {
    var diskinfo = disk[i];
    if (diskinfo.type == "passthrough") {
      var svdom = vmdTemplateAppend('#jv-passthrough-host', 'jvt-passthrough-item', 'jvt-passthrough-item-' + i);
      svdom.attr('style', 'none').data('diskinfo', diskinfo);
      svdom.find('.jvc-model').text(diskinfo.xml.block.model);
      svdom.find('.jvc-volumename').text(diskinfo.path);
      svdom.find('.jvc-driver').text(diskinfo.xml.driver.attributes.type);
      svdom.find('.jvc-device').text(diskinfo.name);
      var capacity = diskinfo.capacity;
      var allocation = diskinfo.allocation;
      var physical = diskinfo.physical;
      capacity && svdom.find('.jvc-capacity').text(UNAS.getReadableSizeString(capacity));
      allocation && svdom.find('.jvc-allocation').text(UNAS.getReadableSizeString(allocation));
      physical && svdom.find('.jvc-physical').text(UNAS.getReadableSizeString(physical));
    }
  }
  vmdTranslator('jv-passthrough-host');
}
//直通pci列表
function get_pci_list(vm) {
  var passthrough = vm.passthrough || {};
  var pci = passthrough.pci || [];
  jQuery('#jv-pcihost').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < pci.length; i++) {
    var tmp_pci = pci[i];
    var pcidom = vmdTemplateAppend('#jv-pcihost', 'jvt-pci-item', 'jvt-pci-item-' + i);
    pcidom.attr('style', 'none').data('diskinfo', tmp_pci);
    var domain = tmp_pci.address.attributes.domain.slice(2);
    var bus = tmp_pci.address.attributes.bus.slice(2);
    var slot = tmp_pci.address.attributes.slot.slice(2);
    var f = tmp_pci.address.attributes['function'].slice(2);
    var address = domain + ':' + bus + ':' + slot + '.' + f;
    pcidom.find('.jvc-address').text(address);
    if (tmp_pci.info) {
      var vendor_id = tmp_pci.info.vendor_id.slice(2);
      var product_id = tmp_pci.info.product_id.slice(2);
      var id = vendor_id + ':' + product_id;
      pcidom.find('.jvc-id').text(id);
      pcidom.find('.jvc-driver').text(tmp_pci.info.driver_name);
      var name = tmp_pci.info.vendor_name + " " + tmp_pci.info.product_name;
      pcidom.find('.jvc-pciname').text(name);
    }

    if (state == 1) {
      pcidom.find('.delete-icon').hide();
    } else if (state == 5) {
      if (reason == 5) {
        pcidom.find('.delete-icon').hide();
      } else {
        pcidom.find('.delete-icon').show();
      }
    }

  }
  vmdTranslator('jv-pcihost');
}
//直通usb列表
function get_usb_list(vm) {
  var passthrough = vm.passthrough || {};
  var usb = passthrough.usb || [];
  jQuery('#jv-usbhost').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < usb.length; i++) {
    var tmp_usb = usb[i];
    var usbdom = vmdTemplateAppend('#jv-usbhost', 'jvt-usb-item', 'jvt-usb-item-' + i);
    usbdom.attr('style', 'none').data('diskinfo', tmp_usb);

    var vendor_id = tmp_usb.vendor_id.slice(2);
    var product_id = tmp_usb.product_id.slice(2);
    var id = vendor_id + ':' + product_id;
    usbdom.find('.jvc-usbid').text(id);
    usbdom.find('.jvc-usbtype').text(tmp_usb.type);
    var name = tmp_usb.vendor_name + " " + tmp_usb.product_name;
    usbdom.find('.jvc-usbname').text(name);

  }
  vmdTranslator('jv-usbhost');
}
//快照列表
function get_snapshots_list(vm) {
  var snapshot = vm.snapshot || [];
  jQuery('#jv-snapshotshost').empty();
  var state = vm.state.state;
  var reason = vm.state.reason;

  for (var i = 0; i < snapshot.length; i++) {
    var tmp_snapshot = snapshot[i];
    var snapshotdom = vmdTemplateAppend('#jv-snapshotshost', 'jvt-snapshots-item', 'jvt-snapshots-item-' + i);
    snapshotdom.attr('style', 'none').data('diskinfo', tmp_snapshot);
    snapshotdom.find('.jvc-snapshotsnmae').text(tmp_snapshot.name).attr('sort',tmp_snapshot.name);
    snapshotdom.find('.jvc-description').text(tmp_snapshot.description);
    var timestamp = +tmp_snapshot.creationTime * 1000;
    var date = new Date(timestamp).toLocaleString().replace(/\//g, '-');
    snapshotdom.find('.jvc-creationtime').text(date).attr('sort',tmp_snapshot.creationTime);
    snapshotdom.find('.jvc-snapshotsstate').addClass(tmp_snapshot.state).text('##$@vmdashboard@$##' + tmp_snapshot.state + '##$@vmdashboard@$##');

    snapshotdom.find('input[type=checkbox]').on('click', function() {
      var len = jQuery('#jv-snapshotshost input[type=checkbox]').length;
      var c_len = jQuery('#jv-snapshotshost input[type=checkbox]:checked').length;
      if (len == c_len) {
        jQuery('#jv-selallsnapshots').prop('checked', true);
      } else {
        jQuery('#jv-selallsnapshots').prop('checked', false);
      }
    })

    snapshotdom.find('.view-icon').on('click', function() {
      var diskinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      viewVmConfigWindowFun('snapshot', diskinfo.name, vm.uuid);
    })

    //恢复快照
    snapshotdom.find('.revert-icon').on('click', function() {
      var diskinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      var params = {
        domain: vmdetailinfo.uuid,
        snapshot: diskinfo.name
      }
      vm_confirmalertWindowFn({
        tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to ##$@vmdashboard@$##') + UNAS._('##$@vmdashboard@$##Revert snapshot##$@vmdashboard@$##') + '?'
      }, function() {
        jQuery('#jv-vmpage-loading').show();
        jQuery.ajax({
          type: "POST",
          url: vmUrl,
          dataType: 'json',
          data: JSON.encode({
            cmd: 'vm_snapshot_revert',
            token: UToken,
            params: params
          }),
          contentType: 'application/json;charset=utf-8',
          success: function(res) {
            vm_confirmalertWindowFn({
              tips: UNAS._('Revert start. Please refer to log for details')
            });
          },
          complete: function(XMLHttpRequest, textStatus) {
            jQuery('#jv-vmpage-loading').hide();
            vm_log();
          },
          error: function(XMLHttpRequest, textStatus, errorThrown) {}
        });

      });


    });
    //删除快照
    snapshotdom.find('.delete-icon').on('click', function() {
      var diskinfo = jQuery(this).parents('ul[name=vmditem]').data('diskinfo');
      var params = {
        domain: vmdetailinfo.uuid,
        snapshot: [diskinfo.name],
        child: false
      }
      vm_snapshot_del(params);
    })
  }
}

function delvmdetsnapshot_s() {
  var snapshot = [];
  jQuery('#jv-snapshotshost input[type=checkbox]:checked').each(function(i, e) {
    var diskinfo = jQuery(e).parents('ul[name=vmditem]').data('diskinfo');
    snapshot.push(diskinfo.name);
  })

  if (snapshot.length) {
    var params = {
      domain: vmdetailinfo.uuid,
      snapshot: snapshot,
      child: false
    }
    vm_snapshot_del(params);
  }
}

function vm_snapshot_del(params) {
  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
  }, function() {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: 'vm_snapshot_del',
        token: UToken,
        params: params
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        if (res.err == 0) {
          getvmdetail();
        } else {
          vm_errorWindowFn({
            tips: UNAS._('Operation failed, please check the log')
          })
        }
      },
      complete: function(XMLHttpRequest, textStatus) {
        vm_log();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  });
}

function vm_domain_stat_detail(uuids) {

  clearTimeout(window.vmdetailcuptimer);
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_domain_stat',
      token: UToken,
      params: {
        domains: uuids
      }
    }),
    success: function(res) {
      var info = res.results || [];
      for (var i = 0; i < info.length; i++) {
        var tmp = info[i];
        var cputime1 = 0;
        var datatime1 = 0;
        if (tmp.cpu) {
          cputime1 = tmp.cpu.time || 0;
        }
        if (tmp.time) {
          datatime1 = tmp.time || 0;
        }
        var cpuinfo = jQuery('#jv-vmdetail-page').data('vmdetailinfo');

        var usemem = '0MB';
        if (tmp.mem) {
          usemem = UNAS.getReadableSizeString(tmp.mem['7'] * 1024);
        }

        jQuery('#jv-memory-chart').text(usemem);
        var cputime0 = 0;
        var datatime0 = 0;
        var p = 0;
        if (cpuinfo) {
          if (cpuinfo.cpu) {
            cputime0 = cpuinfo.cpu.time;
          }
          if (cpuinfo.time) {
            datatime0 = cpuinfo.time;
          }
        }
        p = (cputime1 - cputime0) / (datatime1 - datatime0);
        p = isNaN(p) ? 0 : parseInt(p * 100);
        p = p ? parseInt((p / vmdetailinfo.vcpu.current)) : 0;
        if (p > 100) {
          p = 100;
        } else if (p < 0) {
          p = 0;
        }
        if (jQuery('#jv-vmdetail-page').length) {
          set_cpu_memory("jv-cpu-chart", p);
        }
      }

      diskReadData_vmdetail(info[0]);
      netData_vmdetail(info[0]);

      for (var i = 0; i < info.length; i++) {
        var tmp = info[i];
        jQuery('#jv-vmdetail-page').data('vmdetailinfo', tmp);
      }

      if (jQuery('#jv-vmdetail-page').length) {
        window.vmdetailcuptimer = setTimeout(function() {
          vm_domain_stat_detail(uuids);
          clearTimeout(window.vmdetailcuptimer);
        }, 3000);
      }


    },
    complete: function(XMLHttpRequest, textStatus) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}

function diskReadData_vmdetail(disk) {

  var diskinfo = jQuery('#jv-vmdetail-page').data('vmdetailinfo');
  var disktime_1 = disk.time || 0;
  var rd_bytes_1 = 0;
  var wr_bytes_1 = 0;

  var disktime_0 = 0;
  var rd_bytes_0 = 0;
  var wr_bytes_0 = 0;

  for (var i = 0; i < disk.block.length; i++) {
    var temp_disk = disk.block[i];
    rd_bytes_1 += temp_disk.stat.rd_bytes;
    wr_bytes_1 += temp_disk.stat.wr_bytes;
  }

  if (diskinfo) {
    disktime_0 = diskinfo.time || 0;
    for (var j = 0; j < diskinfo.block.length; j++) {
      var old_tempdiskinfo = diskinfo.block[j];
      rd_bytes_0 += old_tempdiskinfo.stat.rd_bytes;
      wr_bytes_0 += old_tempdiskinfo.stat.wr_bytes;
    }
    var rd_bytes = (rd_bytes_1 - rd_bytes_0) * 1000000000 / (disktime_1 - disktime_0);
    var wr_bytes = (wr_bytes_1 - wr_bytes_0) * 1000000000 / (disktime_1 - disktime_0);
    rd_bytes = isNaN(rd_bytes) ? 0 : parseInt(rd_bytes);
    wr_bytes = isNaN(wr_bytes) ? 0 : parseInt(wr_bytes);
    rd_bytes = rd_bytes < 0 ? 0 : rd_bytes;
    wr_bytes = wr_bytes < 0 ? 0 : wr_bytes;

    jQuery('#jv-vmread').text(UNAS.getReadableSpeedString(rd_bytes));
    jQuery('#jv-vmwrite').text(UNAS.getReadableSpeedString(wr_bytes));
    if (diskReadData.length > 31) {
      diskReadData.pop();
      diskWriteData.pop();
    }

    diskReadData.unshift(rd_bytes)

    diskReadChart.setOption({
      series: [{
        data: diskReadData
      }]
    });

    diskWriteData.unshift(wr_bytes)

    diskWriteChart.setOption({
      series: [{
        data: diskWriteData
      }]
    });
  }
}

function netData_vmdetail(info) {

  var netinfo = jQuery('#jv-vmdetail-page').data('vmdetailinfo');
  var nettime_1 = info.time || 0;
  var rx_bytes_1 = 0;
  var tx_bytes_1 = 0;

  var nettime_0 = 0;
  var rx_bytes_0 = 0;
  var tx_bytes_0 = 0;

  for (var v in info.net) {
    if (info.net.hasOwnProperty(v)) {
      rx_bytes_1 += info.net[v].rx_bytes;
      tx_bytes_1 += info.net[v].tx_bytes;
    }
  }

  if (netinfo) {
    nettime_0 = netinfo.time || 0;
    for (var v in netinfo.net) {
      if (netinfo.net.hasOwnProperty(v)) {
        rx_bytes_0 += netinfo.net[v].rx_bytes;
        tx_bytes_0 += netinfo.net[v].tx_bytes;
      }
    }

    var rx_bytes = (rx_bytes_1 - rx_bytes_0) * 1000000000 / (nettime_1 - nettime_0);
    var tx_bytes = (tx_bytes_1 - tx_bytes_0) * 1000000000 / (nettime_1 - nettime_0);

    rx_bytes = isNaN(rx_bytes) ? 0 : parseInt(rx_bytes);
    tx_bytes = isNaN(tx_bytes) ? 0 : parseInt(tx_bytes);

    jQuery('#jv-vmreceived').text(UNAS.getReadableSpeedString(rx_bytes));
    jQuery('#jv-vmsent').text(UNAS.getReadableSpeedString(tx_bytes));

    if (network_sent.length > 31) {
      network_sent.pop();
      network_io.pop();
    }

    network_sent.unshift(tx_bytes)

    sentChart.setOption({
      series: [{
        data: network_sent
      }]
    });

    network_io.unshift(rx_bytes)

    receiveChart.setOption({
      series: [{
        data: network_io
      }]
    });
  }

}

function vm_log() {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_log',
      token: UToken,
      params: {
        domain: vmdetailinfo.uuid
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {
      var info = res.results || [];
      jQuery('#jv-timeline-host').empty();
      for (var i = 0; i < info.length; i++) {
        var log_tep = info[i];
        var logdom = vmdTemplateAppend('#jv-timeline-host', 'jvt-entry', 'jvt-entry-' + i);
        var timestamp = log_tep[0] * 1000;
        var date = new Date(timestamp).toLocaleString().replace(/\//g, '-');
        if (log_tep[1] == 'ERROR') {
          logdom.find('.md-0').addClass('title_error');
        } else {
          logdom.find('.md-0').addClass('title_enable');
        }
        logdom.find('.md-0').text(date);
        logdom.find('.md-3').text(log_tep[3]);
        logdom.find('.md-6').html(log_tep[8]).attr('translation', 0);
      }

      vmdTranslator('jv-timeline-host');
    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function viewVmdetailxml() {
  viewVmConfigWindowFun('domain', vmdetailinfo.name, vmdetailinfo.uuid);
}

function autosnapshotWindowFun() {
  var autosnapshotWindow = new MUI.Modal({
    id: 'jv-autosnapshotWindow',
    title: UNAS._("Automatic snapshot"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/autosnapshots.html',
    modal: true,
    modalOverlayClose: false,
    width: 800,
    height: 550
  });
}

function snapshottopologyWindowFun() {
  var snapshottopologyWindow = new MUI.Modal({
    id: 'jv-snapshottopologyWindow',
    title: UNAS._("Snapshot topology diagram"),
    contentURL: '/apps/vmdashboard/pc/vmdetail/snapshottopology.html',
    modal: true,
    modalOverlayClose: false,
    width: 800,
    height: 550
  });
}

//sort
function snapshotsSort(t) {
  var sort = jQuery(t).attr('sort');
  var rowname = (sort == 'name' ? '.jvc-snapshotsnmae' : '.jvc-creationtime');
  if (!jQuery(t).attr('type')) {
    jQuery(t).attr('type', 'descending');
  }

  var tbody = jQuery('#jv-snapshotshost');
  var rows = tbody.children('ul');
  rows = Array.prototype.slice.call(rows, 0);

  if (jQuery(t).attr('type') == 'ascending') {
    jQuery(t).attr('type', 'descending')
      .removeClass('ascending').addClass('descending');
    rows.sort(function(row1, row2) {
      var val1 = jQuery(row1).find(rowname).attr('sort');
      var val2 = jQuery(row2).find(rowname).attr('sort');
      if (val2 > val1) {
        return 1;
      } else if (val2 < val1) {
        return -1;
      } else {
        return 0;
      }
    });

  } else {
    jQuery(t).attr('type', 'ascending')
      .removeClass('descending').addClass('ascending');
    rows.sort(function(row1, row2) {
      var val1 = jQuery(row1).find(rowname).attr('sort');
      var val2 = jQuery(row2).find(rowname).attr('sort');
      if (val1 > val2) {
        return 1;
      } else if (val1 < val2) {
        return -1;
      } else {
        return 0;
      }
    });
  }
  tbody.append(rows);
}

(function() {
  jQuery('#jv-selallsnapshots').click(function(e) {
    if (this.checked) {
      jQuery('#jv-snapshotshost input[type=checkbox]').prop('checked', true);
    } else {
      jQuery('#jv-snapshotshost input[type=checkbox]').prop('checked', false);
    }
  })
})()
