function vm_confirmalertWindowFn(data, fn) {
  var cwh = getClientWH();
  var url = '/apps/vmdashboard/m/page/public/confirmAlert.html?=v=6.1.34&'
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tip'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.88),
    height: parseInt(cwh.h * 0.25),
    addClass: 'delete-modal',
    data: data,
    contentURL: url
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function viewprompt(v) {
  vm_confirmalertWindowFn({
    tips: UNAS._(v),
    closebtn: 0
  });
}

function vm_alertWindowFn(data, fn) {
  var cwh = getClientWH();
  var url = '/apps/vmdashboard/m/page/public/alert.html?=v=6.1.34&'
  if (data.isck) {
    url = '/apps/vmdashboard/m/page/public/alert_ck.html?=v=6.1.34&'
  }
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._(data.title || 'Tip'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.84),
    height: parseInt(cwh.h * 0.42),
    addClass: 'delete-modal',
    data: data,
    contentURL: url
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function vm_errorWindowFn(data) {
  var cwh = getClientWH();
  var errorWindow = new MUI.Modal({
    id: 'jv-errorWindow',
    title: UNAS._('Tip'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.8),
    height: parseInt(cwh.h * 0.42),
    addClass: 'delete-modal',
    data: data,
    contentURL: '/apps/vmdashboard/m/page/public/error.html?=v=6.1.34&'
  });
  errorWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function vm_succeedWindowFn(data) {
  var cwh = getClientWH();
  var succeedWindow = new MUI.Modal({
    id: 'jv-succeedWindow',
    title: UNAS._('Tip'),
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.8),
    height: parseInt(cwh.h * 0.42),
    addClass: 'delete-modal',
    data: data,
    contentURL: '/apps/vmdashboard/m/page/public/succeed.html?=v=6.1.34&'
  });
  succeedWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function selectfiletree(type, t) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var target = event.target;
  var cwh = getClientWH();
  var selectfileWindow = new MUI.Modal({
    id: 'jv-selectfileWindow',
    title: UNAS._("Select Directory"),
    contentURL: '/apps/vmdashboard/m/page/public/selectfile.html',
    modal: true,
    modalOverlayClose: false,
    data: {
      filetype: type,
      target: target
    },
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.8),
    type: 'modal2',
    addClass: 'mobile-modal'
  });
}

function showpage(t, time = 200) {
  setTimeout(function() {
    jQuery(t).animate({
      opacity: '1'
    }, 200);
  }, time)
}

function switchNav() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  event.stopPropagation();
  jQuery('#jv-navContainer').fadeIn();

  jQuery(document).on('click', function(e) {
    e.stopPropagation();
    jQuery('#jv-navContainer').fadeOut();
  })
}

function Trim(str, is_global) {
  var result;
  result = str.replace(/(^\s+)|(\s+$)/g, "");
  if (is_global.toLowerCase() == "g") {
    result = result.replace(/\s/g, "");
  }
  return result;
}

function inputSapceTrim(e, this_temp) {
  this_temp.value = Trim(this_temp.value, "g");
  var keynum;
  if (window.event) // IE
  {
    keynum = e.keyCode
  } else if (e.which) // Netscape/Firefox/Opera
  {
    keynum = e.which
  }
  if (keynum == 32) {
    return false;
  }
  return true;
}

function banInputSapce(e) {
  var keynum;
  if (window.event) // IE
  {
    keynum = e.keyCode
  } else if (e.which) // Netscape/Firefox/Opera
  {
    keynum = e.which
  }
  if (keynum == 32) {
    return false;
  }
  return true;
}


jQuery(document).ready(function() {

  jQuery('#jv-pagetitle').text(navs['vm']);
  updatevmpage('/apps/vmdashboard/m/page/vm/vm.html');
  vmdTranslator('jv-pagetitle');
})
