var urlSearchParams = new URLSearchParams(window.location.search);
// 把键值对列表转换为一个对象
if (!Object.fromEntries) {
  Object.fromEntries = entries => {
    var result = {};
    for (var [key, value] of entries) {
      result[key] = value;
    }
    return result;
  };
}
var params = Object.fromEntries(urlSearchParams.entries());

if (params.l) {
  lan = params.l;
} else if (getCookie('login_lang')) {
  lan = unescape(window.atob(getCookie('login_lang')));
} else {
  lan = sessionStorage.getItem('tempLang') || lan;
}

UNAS.CurrentLanguage = lan;

var UToken;
var tokenArr = document.cookie.split("; ");

if (params.t) {
  UToken = params.t;
} else {
  for (var i = 0; i < tokenArr.length; i++) {
    if (tokenArr[i].search("PHPSESSID") !== -1) {
      UToken = tokenArr[i].split("=")[1]
    }
  }
}

var OnChangeLanguage_vmd = null;
var pageTranslators_vmd = [];
var vmUrl = '/apps/vmdashboard/includes/index.php';
var vmdetailinfo = {};
var vmuuid = '';
var backhtml = '/apps/vmdashboard/m/page/vm/vm.html';
var uploadFilerrcode = {
  '9999': 'File upload failed',
  '9984': 'Not logged in',
  '9996': 'Chunk verification failed',
  '9930': 'Forbid to write into system disk',
  '9993': 'File exists',
  '9916': 'Write failed',
  '9897': 'Open file failed',
}

var navs = {
  host: '##$@vmdashboard@$##Host Information##$@vmdashboard@$##',
  vm: '##$@vmdashboard@$##Virtual Machines##$@vmdashboard@$##',
  storage: '##$@vmdashboard@$##Storage##$@vmdashboard@$##',
  network: '##$@vmdashboard@$##Networking##$@vmdashboard@$##',
  settings: '##$@vmdashboard@$##Settings##$@vmdashboard@$##'
}

UNAS.LoadTranslation('/apps/vmdashboard/languages/Translation?v=6.1.34', function() {}, false);

OnChangeLanguage_vmd = function(e) {
  for (var i = 0; i < pageTranslators_vmd.length; i++) {
    var node = pageTranslators_vmd[i].node;
    var p = pageTranslators_vmd[i].translateProperty;
    node[p] = window.top.UNAS._(pageTranslators_vmd[i].originalText);
  }

  if (e) {

  }

  function vmdTranslator(id) {
    let rt_c = document.getElementById(id);
    if (!rt_c) {
      return;
    }
    var tmp_pageTranslators = window.top.UNAS.CreateNodesTranslators(rt_c);
    pageTranslators_vmd = pageTranslators_vmd.concat(tmp_pageTranslators);
    OnChangeLanguage_vmd();
  }
  window.vmdTranslator = vmdTranslator;
};
OnChangeLanguage_vmd();
window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_vmd);
window.addEventListener("unload", function(e) {
  window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_vmd);
}, false);

function updatevmpage(url, fn) {
  jQuery('#jv-vmd-main').css('opacity', '0');
  jQuery.ajaxSetup({
    cache: false
  });

  jQuery('#jv-vmd-main').load(url, function(res) {
    setTimeout(function() {
      jQuery('#jv-vmd-main').animate({
        opacity: '1'
      }, 200);
      vmdTranslator('jv-vmd-network-page');
    }, 100)
    if (fn && typeof fn === "function") {
      fn();
    }
  })
}




// ----------------------------------
function vmdTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

function generateRandomMacAddress() {
  let macAddress = "00";
  for (let i = 0; i < 5; i++) {
    macAddress += ":" + Math.floor(Math.random() * 256).toString(16).padStart(2, "0");
  }
  return macAddress.toLowerCase();
}

function getClientWH() {
  var clientHeight = 0;
  if (document.body.clientHeight && document.documentElement.clientHeight) {
    clientHeight = Math.min(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.min(document.body.clientWidth, document.documentElement.clientWidth);
  } else {
    clientHeight = Math.max(document.body.clientHeight, document.documentElement.clientHeight);
    clientWidth = Math.max(document.body.clientWidth, document.documentElement.clientWidth);
  }

  return {
    w: clientWidth,
    h: clientHeight
  };
}

(function() {
  jQuery('#jv-vmd-nav .nav-item').each(function(i, e) {
    e.onclick = function() {
      var link = jQuery(this).attr('link');
      if (jQuery(this).hasClass('current-nav-item')) {
        return;
      }
      jQuery(this).addClass('current-nav-item').siblings().removeClass('current-nav-item');
      jQuery('#jv-pagetitle').text(navs[link]);
      updatevmpage('/apps/vmdashboard/m/page/' + link + '/' + link + '.html');
      vmdTranslator('jv-pagetitle');
    }
  })
})();
