var exportVMWindow = window.top.UNAS.GetWindow('jv-exportVMWindow');
var options = exportVMWindow.options;
var pagedata = options.data;

function subexportvm() {
  var storagepath = jQuery('#jv-storagepath').val();
  var name = jQuery('#jv-filename').val();
  if (storagepath) {
    jQuery('#jv-storagepath').attr('class', 'unas_input');
  } else {
    jQuery('#jv-storagepath').attr('class', 'unas_input_error');
    return;
  }

  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_export',
      token: UToken,
      params: {
        domain: pagedata.uuid,
        target_dir: storagepath,
        name: name
      }
    }),
    contentType: 'application/json;charset=utf-8',
    success: function(res) {

      if (res.err == 0) {
        vm_bg_tasks();
        MUI.closeWindow($('jv-exportVMWindow'));
      }

    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });


}

function vm_export_list() {
  jQuery.ajax({
    type: "POST",
    url: vmUrl,
    dataType: 'json',
    data: JSON.encode({
      cmd: 'vm_export_list',
      token: UToken,
      params: {
        domain: pagedata.uuid
      }
    }),
    success: function(res) {
      var info = res.results || [];
      jQuery('#jv-importfileinfohost').empty().show();
      for (var i = 0; i < info.length; i++) {
        var dom = vmdTemplateAppend('#jv-importfileinfohost', 'jvt-fileinfoitem', 'jvt-fileinfoitem-' + i);
        dom.attr('style', '');
        dom.find('.name').html(info[i].name);
        if (info[i].info) {
          dom.find('.stat').html(UNAS.getReadableSizeString(info[i].info.physical));
        }
      }
    },
    complete: function(XMLHttpRequest, textStatus) {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });

}
(function() {
  showpage('#jv-exportvm-page');
  var name = pagedata.name + '_' + new Date().getTime() + '.ova';
  jQuery('#jv-filename').val(name);
  vm_export_list();
})();
