var current_snp_info = {};
var j = 0;
var tree = null;

function traverse(arr) {
  var current = vmdetailinfo.current;
  jQuery('#jv-snptreehost').empty();
  for (var i = 0; i < arr.length; i++) {
    var tp = arr[i];
    var h = 0;
    tree = vmdTemplateAppend('#jv-snptreehost', 'jvt-snpstitem', 'jvt-snpstitem-' + i);
    tree.find('.snpnun').text(tp.name);
    tree.find('.jvc-time').text(formatDate_vm(+tp.creationTime));
    tree.find('.snpst').data('snpinfo', tp);
    if (current.name == tp.name) {
      tree.find('.snpst').addClass('snpst-current');
      current_snp_info = tp;
    }
    // h = (j * 70);
    // tree.find('.linest').css('height', h + 'px');
    // tree.find('.linest').css('top', -h + 'px');
    tree.find('.snpst').on('click', function() {
      jQuery('.snpst').removeClass('snpst-current');
      jQuery(this).addClass('snpst-current');
      current_snp_info = jQuery(this).data('snpinfo');
    })
    if (tp.children.length) {
      traverse(tp.children);
      tree.find('.childul').empty();
      tree = vmdTemplateAppend(tree.find('.childul'), 'jvt-snpstitem', 'jvt-snpstitem-' + i + j);
      tree.find('.snpnun').text(tp.name);
      tree.find('.jvc-time').text(formatDate_vm(+tp.creationTime));
      tree.find('.snpst').data('snpinfo', tp);
      // tree.find('.linest').css('height', h + 'px');
      // tree.find('.linest').css('top', -h + 'px');
      if (current.name == tp.name) {
        tree.find('.snpst').addClass('snpst-current');
        current_snp_info = tp;
      }
      tree.find('.snpst').on('click', function() {
        jQuery('.snpst').removeClass('snpst-current');
        jQuery(this).addClass('snpst-current');
        current_snp_info = jQuery(this).data('snpinfo');
      })
      j++;
    } else {

    }
  }
}

function refreshsnapshot() {
  var snapshot = vmdetailinfo.snapshot || [];
  current_snp_info = vmdetailinfo.current;
  var snapshot_now = [];
  for (var i = 0; i < snapshot.length; i++) {
    if (!snapshot[i].parent) {
      snapshot_now.unshift(snapshot[i]);
    } else {
      snapshot_now.push(snapshot[i]);
    }
  }
  var tree_snapshots = buildTree(snapshot);
  // console.log(tree_snapshots);
  if (tree_snapshots.length) {
    jQuery('#jv-roothost').empty();
    var tp = tree_snapshots[0];
    var root = vmdTemplateAppend('#jv-roothost', 'jvt-rootitem', 'jvt-rootitem');
    root.find('.snpnun').text(tp.name);
    root.find('.jvc-time').text(formatDate_vm(+tp.creationTime));
    root.find('.snpst').data('snpinfo', tp);
    root.find('.snpst').on('click', function() {
      jQuery('.snpst').removeClass('snpst-current');
      jQuery(this).addClass('snpst-current');
      current_snp_info = jQuery(this).data('snpinfo');
    })
    // tree_snapshots[0].children[0].children.push({
    //   name : '0000',
    // })
    traverse(tree_snapshots[0].children);

  } else {
    jQuery('#jv-snapshottopologypage').html('');
  }

}
//创建快照
function createsnapshot_st() {
  createSnapshotWindowFun('st');
}
//恢复
function vmsnapshotrevert() {

  var params = {
    domain: vmdetailinfo.uuid,
    snapshot: current_snp_info.name
  }
  vm_confirmalertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to ##$@vmdashboard@$##') + UNAS._('##$@vmdashboard@$##Revert snapshot##$@vmdashboard@$##') + '?'
  }, function() {
    jQuery('#jv-vmpage-loading').show();
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: 'vm_snapshot_revert',
        token: UToken,
        params: params
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        vm_confirmalertWindowFn({
          tips: UNAS._('Revert start. Please refer to log for details')
        });
        MUI.closeWindow($('jv-snapshottopologyWindow'));
      },
      complete: function(XMLHttpRequest, textStatus) {
        jQuery('#jv-vmpage-loading').hide();
        vm_log();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });

  });
}

function viewsnapshot() {
  viewVmConfigWindowFun('snapshot', current_snp_info.name, vmdetailinfo.uuid);
}
//删除当前快照
function deletecurrentsnp() {
  var params = {
    domain: vmdetailinfo.uuid,
    snapshot: [current_snp_info.name],
    child: false
  }
  vm_snapshot_del_st(params);
}
//全部删除
function deleteall() {
  var snapshot = [];
  for (var i = 0; i < vmdetailinfo.snapshot.length; i++) {
    var tp = vmdetailinfo.snapshot[i];
    snapshot.push(tp.name);
  }
  var params = {
    domain: vmdetailinfo.uuid,
    snapshot: snapshot,
    child: false
  }
  vm_snapshot_del_st(params);
}


function vm_snapshot_del_st(params) {
  vm_alertWindowFn({
    tips: UNAS._('##$@vmdashboard@$##Are you sure you wish to delete##$@vmdashboard@$##') + '?'
  }, function() {
    jQuery.ajax({
      type: "POST",
      url: vmUrl,
      dataType: 'json',
      data: JSON.encode({
        cmd: 'vm_snapshot_del',
        token: UToken,
        params: params
      }),
      contentType: 'application/json;charset=utf-8',
      success: function(res) {
        if (res.err == 0) {
          getvmdetail().then(function() {
            refreshsnapshot();
          })
        } else {
          vm_errorWindowFn({
            tips: UNAS._('Operation failed, please check the log')
          })
        }
      },
      complete: function(XMLHttpRequest, textStatus) {
        vm_log();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  });
}

function buildTree(snapshots) {
  const map = new Map();
  const root = [];
  // 创建所有节点，并将它们存储在 map 中
  snapshots.forEach(snapshot => {
    snapshot.children = [];
    map.set(snapshot.name, snapshot);
  });
  // 将节点关联到它们的父节点
  snapshots.forEach(snapshot => {
    if (snapshot.parent) {
      const parent = map.get(snapshot.parent.name);
      if (parent) {
        parent.children.push(snapshot);
      }
    } else {
      // 如果没有父节点，就添加到根节点
      root.push(snapshot);
    }
  });
  return root;
}

(function() {
  refreshsnapshot();
})();
